package com.kingdee.eas.custom.jiuzhoutong.utils;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.eas.base.permission.UserInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.interfaceiog.LogInfoFactory;
import com.kingdee.eas.custom.shuiyou.interfaceiog.LogInfoInfo;
import org.apache.log4j.Logger;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.SignatureException;
import java.sql.Timestamp;
import java.util.*;

public class SYUtils {
    private Properties propt = new Properties();//ò
    private static Logger logger = Logger.getLogger("com.kingdee.eas.custom.jiuzhoutong.utils.SYUtils");

    public  SYUtils(Properties propt){
        this.propt=propt;
    }
    public  SYUtils(String address) throws IOException {
        this.propt.load(new FileInputStream(address));
    }

    public  SYUtils() throws IOException {
        this.propt.load(new FileInputStream(System.getProperty("EAS_HOME") + "/server/properties/sy/syConfig.properties"));
    }
    /**
     * ȡǩ
     * @return
     * @throws IOException
     */
    public  String getSignature(String xReqNonce,String timestamp,TreeMap<String, String> getParam) throws IOException {
        logger.error("====ȡǩ===뵽com.kingdee.eas.custom.jiuzhoutong.utils.SYUtils.getSignature=======");
        TreeMap<String, String> treeMap = new TreeMap<>();
        String version = propt.getProperty("version");//汾
        String appKey = propt.getProperty("appKey");//ݱʶ
        String appSecret = propt.getProperty("appSecret");//Կ
        logger.error("=============================");
        logger.error("version"+version);
        logger.error("appKey"+appKey);
        logger.error("xReqNonce"+xReqNonce);
        logger.error("appSecret"+appSecret);
        logger.error("==================================");
        treeMap.put("version", version);
        treeMap.put("timestamp", String.valueOf(timestamp));
        treeMap.put("appKey", appKey);
        treeMap.put("xReqNonce", xReqNonce);
        treeMap.put("appSecret", appSecret);
        if (getParam!=null){
            treeMap.putAll(getParam);
        }
        StringBuilder mergeStr = new StringBuilder();
        for (Map.Entry<String, String> stringStringEntry : treeMap.entrySet()) {
            mergeStr.append(stringStringEntry.getValue());
        }
        logger.error("key=valueԵvalueкϲ,һַmergeStr"+mergeStr.toString());
        String encodedStr = null;
        try {
            encodedStr = URLEncoder.encode(mergeStr.toString(), "UTF-8");
        } catch (UnsupportedEncodingException e) {
            // URL ʧ
            e.printStackTrace();
            throw new RuntimeException("urlʧ");
        }
        logger.error("ɵmergeStrUrl룺"+encodedStr);

        // 4.HmacSHA256㷨signStrйϣϢժҪ,ժҪBase64ʽأsignStrΪеsignatureֶ
        String signatureResult = "";
        try {
            Mac mac = Mac.getInstance("HmacSHA256");
            SecretKeySpec signingKey = new SecretKeySpec(appSecret.getBytes(), "HmacSHA256");
            mac.init(signingKey);
            byte[] signData = mac.doFinal(encodedStr.getBytes());
            byte[] resultBytes = Base64.getEncoder().encode(signData);
            signatureResult = new String(resultBytes, "UTF-8");
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException("ƽ̨֧ HmacSHA ժҪʽ");
        } catch (InvalidKeyException e) {
            throw new RuntimeException("Speicified access secret is not valid.");
        } catch (UnsupportedEncodingException e) {
            throw new RuntimeException("תʧ");
        }
        logger.error("HmacSHA256㷨signStrйϣϢժҪ,ժҪBase64ʽأsignStrΪеsignatureֶ"+signatureResult);
        logger.error("==========================˳================================");
        return signatureResult;
    }

    public Map<String,String> getCommonParameter(TreeMap<String, String> getParam) throws IOException {
        String appKey = propt.getProperty("appKey");
        String timestamp = String.valueOf(new Date().getTime());
        String version = propt.getProperty("version");
        String xReqNonce = UUID.randomUUID().toString().replace("-", "");//ɵ UUID(32λ)ʱtimestamp ط
        String signature = this.getSignature(xReqNonce,timestamp,getParam);
        Map<String,String> parameters = new HashMap<String,String>();
        parameters.put("appKey",appKey);
        parameters.put("timestamp",timestamp);
        parameters.put("version",version);
        parameters.put("xReqNonce",xReqNonce);
        parameters.put("signature",signature);
        return parameters;
    }

    /**
     *
     * @param context 
     * @param error Ϣ
     * @param interfaceAddress ӿڵַ
     * @param interfaceName ӿ
     * @param inParameter 
     * @param outParameter ز
     * @param entrance 
     * @param xReqNonce uuid
     * @throws BOSException
     * @throws EASBizException
     */
    public void interfaceLog(Context context,String error,String interfaceAddress
                        ,String interfaceName,String inParameter,String outParameter
                        ,String entrance,String xReqNonce) {
        LogInfoInfo logInfo = new LogInfoInfo();
        logInfo.setErrorInfo(error);//Ϣ
        logInfo.setInterfaceAddress(interfaceAddress);//ӿڵַ
        logInfo.setInterfaceName(interfaceName);//ӿ
        logInfo.setInParameter(inParameter);//
        logInfo.setOutParameter(outParameter);//ز
        logInfo.setEntrance(entrance);//
        UserInfo userInfo = (UserInfo)context.get("UserInfo");
        logInfo.setCreator(userInfo);
        Date date = new Date();
        Timestamp timestamp = new Timestamp(date.getTime());
        logInfo.setCreateTime(timestamp);
        logInfo.setLastUpdateTime(timestamp);
        logInfo.setLastUpdateUser(userInfo);
        logInfo.setBizDate(date);
        logInfo.setXReqNonce(xReqNonce);
        try {
            LogInfoFactory.getLocalInstance(context).save(logInfo);
        } catch (BOSException e) {
            throw new RuntimeException(e);
        } catch (EASBizException e) {
            throw new RuntimeException(e);
        }
    }


}
